Scatter with Jitter in JavaScript

Using ApexCharts with JavaScript

This Scatter with Jitter example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(20240607)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

// Individual API response-time readings per data-centre region. Compact
// strip-plot form: { x: 'Region', y: [reading, reading, ...] }. Every reading
// becomes its own hoverable marker, scattered horizontally within its band.
var REGIONS = [
  { name: 'Frankfurt', mean: 120, sd: 22 },
  { name: 'Mumbai', mean: 182, sd: 30 },
  { name: 'Oregon', mean: 96, sd: 18 },
  { name: 'Singapore', mean: 158, sd: 26 },
  { name: 'Virginia', mean: 82, sd: 16 },
]

function readings(region) {
  var out = []
  for (var i = 0; i < 150; i++) {
    out.push(Math.max(20, Math.round(gauss(region.mean, region.sd))))
  }
  return out
}

var options = {
  series: [
    {
      name: 'Frankfurt',
      data: [{ x: 'Frankfurt', y: readings(REGIONS[0]) }],
    },
    {
      name: 'Mumbai',
      data: [{ x: 'Mumbai', y: readings(REGIONS[1]) }],
    },
    {
      name: 'Oregon',
      data: [{ x: 'Oregon', y: readings(REGIONS[2]) }],
    },
    {
      name: 'Singapore',
      data: [{ x: 'Singapore', y: readings(REGIONS[3]) }],
    },
    {
      name: 'Virginia',
      data: [{ x: 'Virginia', y: readings(REGIONS[4]) }],
    },
  ],
  chart: {
    type: 'scatter',
    height: 460,
  },
  title: {
    text: 'API response time by region',
    align: 'center',
  },
  plotOptions: {
    scatter: {
      // Spread the readings in each band horizontally (axis units; 1 = one
      // band step). Set `distributed: true` to colour each band differently.
      jitter: {
        enabled: true,
        x: 0.35,
      },
    },
  },
  markers: {
    size: 3,
    strokeWidth: 0,
  },
  fill: {
    opacity: 0.6,
  },
  legend: { show: false },
  xaxis: {
    // strip plots read better without the vertical crosshair line
    crosshairs: { show: false },
  },
  yaxis: {
    title: { text: 'Response time (ms)' },
    labels: {
      formatter: function (v) {
        return Math.round(v)
      },
    },
  },
  tooltip: {
    // anchor the tooltip to the hovered band so it stays put instead of
    // chasing each individual marker
    shared: true,
    intersect: false,
    y: {
      formatter: function (v) {
        return Math.round(v) + ' ms'
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Scatter with Jitter in Angular

Using ApexCharts with Angular

This Scatter with Jitter example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (a: any): any => {
          return function () {
            a |= 0
            a = (a + 0x6d2b79f5) | 0
            var t = Math.imul(a ^ (a >>> 15), 1 | a)
            t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
            return ((t ^ (t >>> 14)) >>> 0) / 4294967296
          }
        };

  private rng: any = this.mulberry32(20240607);

  private gauss = (mean: any, sd: any): any => {
          var u = 0,
            v = 0
          while (u === 0) u = this.rng()
          while (v === 0) v = this.rng()
          return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
        };

  private REGIONS: any = [
          { name: 'Frankfurt', mean: 120, sd: 22 },
          { name: 'Mumbai', mean: 182, sd: 30 },
          { name: 'Oregon', mean: 96, sd: 18 },
          { name: 'Singapore', mean: 158, sd: 26 },
          { name: 'Virginia', mean: 82, sd: 16 },
        ];

  private readings = (region: any): any => {
          var out = []
          for (var i = 0; i < 150; i++) {
            out.push(Math.max(20, Math.round(this.gauss(region.mean, region.sd))))
          }
          return out
        };

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Frankfurt',
              data: [{ x: 'Frankfurt', y: this.readings(this.REGIONS[0]) }],
            },
            {
              name: 'Mumbai',
              data: [{ x: 'Mumbai', y: this.readings(this.REGIONS[1]) }],
            },
            {
              name: 'Oregon',
              data: [{ x: 'Oregon', y: this.readings(this.REGIONS[2]) }],
            },
            {
              name: 'Singapore',
              data: [{ x: 'Singapore', y: this.readings(this.REGIONS[3]) }],
            },
            {
              name: 'Virginia',
              data: [{ x: 'Virginia', y: this.readings(this.REGIONS[4]) }],
            },
          ],
          chart: {
            type: 'scatter',
            height: 460,
          },
          title: {
            text: 'API response time by region',
            align: 'center',
          },
          plotOptions: {
            scatter: {
              // Spread the readings in each band horizontally (axis units; 1 = one
              // band step). Set `distributed: true` to colour each band differently.
              jitter: {
                enabled: true,
                x: 0.35,
              },
            },
          },
          markers: {
            size: 3,
            strokeWidth: 0,
          },
          fill: {
            opacity: 0.6,
          },
          legend: { show: false },
          xaxis: {
            // strip plots read better without the vertical crosshair line
            crosshairs: { show: false },
          },
          yaxis: {
            title: { text: 'Response time (ms)' },
            labels: {
              formatter: (v) => {
                return Math.round(v)
              },
            },
          },
          tooltip: {
            // anchor the tooltip to the hovered band so it stays put instead of
            // chasing each individual marker
            shared: true,
            intersect: false,
            y: {
              formatter: (v) => {
                return Math.round(v) + ' ms'
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Scatter with Jitter in Vue

Using ApexCharts with Vue

This Scatter with Jitter example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="scatter"
        height="460"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(20240607)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

// Individual API response-time readings per data-centre region. Compact
// strip-plot form: { x: 'Region', y: [reading, reading, ...] }. Every reading
// becomes its own hoverable marker, scattered horizontally within its band.
var REGIONS = [
  { name: 'Frankfurt', mean: 120, sd: 22 },
  { name: 'Mumbai', mean: 182, sd: 30 },
  { name: 'Oregon', mean: 96, sd: 18 },
  { name: 'Singapore', mean: 158, sd: 26 },
  { name: 'Virginia', mean: 82, sd: 16 },
]

function readings(region) {
  var out = []
  for (var i = 0; i < 150; i++) {
    out.push(Math.max(20, Math.round(gauss(region.mean, region.sd))))
  }
  return out
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Frankfurt',
          data: [{ x: 'Frankfurt', y: readings(REGIONS[0]) }],
        },
        {
          name: 'Mumbai',
          data: [{ x: 'Mumbai', y: readings(REGIONS[1]) }],
        },
        {
          name: 'Oregon',
          data: [{ x: 'Oregon', y: readings(REGIONS[2]) }],
        },
        {
          name: 'Singapore',
          data: [{ x: 'Singapore', y: readings(REGIONS[3]) }],
        },
        {
          name: 'Virginia',
          data: [{ x: 'Virginia', y: readings(REGIONS[4]) }],
        },
      ],
      chartOptions: {
        chart: {
          type: 'scatter',
          height: 460,
        },
        title: {
          text: 'API response time by region',
          align: 'center',
        },
        plotOptions: {
          scatter: {
            // Spread the readings in each band horizontally (axis units; 1 = one
            // band step). Set `distributed: true` to colour each band differently.
            jitter: {
              enabled: true,
              x: 0.35,
            },
          },
        },
        markers: {
          size: 3,
          strokeWidth: 0,
        },
        fill: {
          opacity: 0.6,
        },
        legend: { show: false },
        xaxis: {
          // strip plots read better without the vertical crosshair line
          crosshairs: { show: false },
        },
        yaxis: {
          title: { text: 'Response time (ms)' },
          labels: {
            formatter: function (v) {
              return Math.round(v)
            },
          },
        },
        tooltip: {
          // anchor the tooltip to the hovered band so it stays put instead of
          // chasing each individual marker
          shared: true,
          intersect: false,
          y: {
            formatter: function (v) {
              return Math.round(v) + ' ms'
            },
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 760px;
  margin: 20px auto;
}
</style>

Scatter with Jitter in React

Using ApexCharts with React

This Scatter with Jitter example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(20240607)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

// Individual API response-time readings per data-centre region. Compact
// strip-plot form: { x: 'Region', y: [reading, reading, ...] }. Every reading
// becomes its own hoverable marker, scattered horizontally within its band.
var REGIONS = [
  { name: 'Frankfurt', mean: 120, sd: 22 },
  { name: 'Mumbai', mean: 182, sd: 30 },
  { name: 'Oregon', mean: 96, sd: 18 },
  { name: 'Singapore', mean: 158, sd: 26 },
  { name: 'Virginia', mean: 82, sd: 16 },
]

function readings(region) {
  var out = []
  for (var i = 0; i < 150; i++) {
    out.push(Math.max(20, Math.round(gauss(region.mean, region.sd))))
  }
  return out
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Frankfurt',
        data: [{ x: 'Frankfurt', y: readings(REGIONS[0]) }],
      },
      {
        name: 'Mumbai',
        data: [{ x: 'Mumbai', y: readings(REGIONS[1]) }],
      },
      {
        name: 'Oregon',
        data: [{ x: 'Oregon', y: readings(REGIONS[2]) }],
      },
      {
        name: 'Singapore',
        data: [{ x: 'Singapore', y: readings(REGIONS[3]) }],
      },
      {
        name: 'Virginia',
        data: [{ x: 'Virginia', y: readings(REGIONS[4]) }],
      },
    ],
    options: {
      chart: {
        type: 'scatter',
        height: 460,
      },
      title: {
        text: 'API response time by region',
        align: 'center',
      },
      plotOptions: {
        scatter: {
          // Spread the readings in each band horizontally (axis units; 1 = one
          // band step). Set `distributed: true` to colour each band differently.
          jitter: {
            enabled: true,
            x: 0.35,
          },
        },
      },
      markers: {
        size: 3,
        strokeWidth: 0,
      },
      fill: {
        opacity: 0.6,
      },
      legend: { show: false },
      xaxis: {
        // strip plots read better without the vertical crosshair line
        crosshairs: { show: false },
      },
      yaxis: {
        title: { text: 'Response time (ms)' },
        labels: {
          formatter: function (v) {
            return Math.round(v)
          },
        },
      },
      tooltip: {
        // anchor the tooltip to the hovered band so it stays put instead of
        // chasing each individual marker
        shared: true,
        intersect: false,
        y: {
          formatter: function (v) {
            return Math.round(v) + ' ms'
          },
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="scatter"
          height={460}
        />
      </div>
    </div>
  )
}

export default ApexChart